"{ Package: 'stx:libjava/tools' }"

Object subclass:#JavaParseNodeBuilder
	instanceVariableNames:'start stop line'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Parser-AST'
!

!JavaParseNodeBuilder class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!JavaParseNodeBuilder methodsFor:'accessing'!

start
    ^ start
!

start:something
    start := something.
!

start: startPos stop: stopPos
    start := startPos.
    stop := stopPos.

    "Created: / 22-04-2013 / 18:15:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

stop
    ^ stop
!

stop:something
    stop := something.
! !

!JavaParseNodeBuilder methodsFor:'building'!

new: parseNodeClass
    ^parseNodeClass new
        startPosition: start;
        stopPosition: stop;
        line: line;
        yourself

    "Created: / 22-04-2013 / 18:19:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newClassDeclaration_modifiers: modifiers
                    name: name
                    typeParameters: typeParameters
                    superclass: superclass
                    interfaces: interfaces
                    members: members 

    ^ (self new:JavaClassDeclarationNode)
                    modifiers: modifiers;
                    name: name;
                    typeParameters: typeParameters;
                    superclass: superclass;
                    interfaces: interfaces;
                    members: members;
                    yourself

    "Created: / 04-04-2013 / 00:08:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2013 / 10:52:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newConstructorDeclaration_modifiers: modifiers
                     typeParameters: typeParameters
                         parameters: parameters
                         exceptions: exceptions
                               body: body            

    ^ (self new:JavaConstructorDeclarationNode)
                     modifiers: modifiers;
                typeParameters: typeParameters;
                    parameters: parameters;
                    exceptions: exceptions;
                          body: body;
                                yourself

    "Created: / 24-08-2013 / 02:05:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2013 / 10:52:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newImportDeclaration: name
    ^(self new:JavaImportDeclarationNode)
        name: name;
        yourself

    "Created: / 25-08-2013 / 11:45:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newMethodDeclaration_modifiers: modifiers
                typeParameters: typeParameters
                    returnType: returnType
                          name: name
                    parameters: parameters
                    exceptions: exceptions
                          body: body    

    ^ (self new: JavaMethodDeclarationNode)
                     modifiers: modifiers;
                typeParameters: typeParameters;
                    returnType: returnType;
                          name: name;
                    parameters: parameters;
                    exceptions: exceptions;
                          body: body;
                                yourself

    "Created: / 24-08-2013 / 02:03:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2013 / 10:52:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newPackageDeclaration: name
    ^(self new:JavaPackageDeclarationNode)
        name: name;
        yourself

    "Created: / 03-04-2013 / 23:49:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2013 / 10:52:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newSourceFile_package: package imports: imports types: types
    ^(self new:JavaSourceFile)
        package: package;
        imports: imports;
        types: types;
        yourself

    "Created: / 03-04-2013 / 23:21:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2013 / 10:52:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

newStringLiteral:aString
    ^(self new: JavaLiteralNode)
        value: aString;
        yourself

    "Created: / 22-04-2013 / 18:21:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaParseNodeBuilder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjava/tools/JavaParseNodeBuilder.st,v 1.2 2013-02-25 11:15:35 vrany Exp $'
!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_SVN
    ^ 'Id'
! !

